unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, DB, ADODB, Grids, DBGrids, StdCtrls, ComCtrls,
  math, Mask, DBCtrls,  
  ExtCtrls;

type
  TForm1 = class(TForm)
    dsrCarRental: TDataSource;
    DbgCars: TDBGrid;
    ADOTblModels: TADOTable;
    conCarRental: TADOConnection;
    ADOTblRentals: TADOTable;
    ADOTblGroups: TADOTable;
    ADOTblModelsModelID: TFloatField;
    ADOTblModelsModelName: TWideStringField;
    ADOTblModelsAC: TBooleanField;
    ADOTblModelsABS_brakes: TBooleanField;
    ADOTblModelsTank: TFloatField;
    ADOTblModelsSeats: TFloatField;
    ADOTblModelsRange: TFloatField;
    ADOTblRentalsID: TAutoIncField;
    ADOTblRentalsCarRegistration: TWideStringField;
    ADOTblRentalsDate_from: TDateTimeField;
    ADOTblRentalsDate_until: TDateTimeField;
    ADOTblRentalsModelID: TFloatField;
    ADOTblGroupsGroupID: TWideStringField;
    ADOTblGroupsGroupdescription: TWideStringField;
    ADOTblGroupsRate_per_day: TBCDField;
    ADOTblModelsGroupID: TWideStringField;
    ADOTblModelsAUTO: TBooleanField;
    ADOTblModelsPower_Steering: TBooleanField;
    ADOTblModelsCentral_locking: TBooleanField;
    ADOTblModelsAir_Bags: TBooleanField;
    ADOTblModelsDoors: TFloatField;
    cmbTable: TComboBox;
    ADOQry: TADOQuery;
    procedure FormCreate(Sender: TObject);
    procedure cmbTableChange(Sender: TObject);

  


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}



procedure TForm1.cmbTableChange(Sender: TObject);
begin
case cmbTable.ItemIndex of
0:  dsrCarRental.DataSet := ADOTblModels;
1:  dsrCarRental.DataSet := ADOTblRentals;
2:  dsrCarRental.DataSet := ADOTblGroups;
end;
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
conCarRental.Close;
conCarRental.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source='
+ExtractFilePath(Application.ExeName) +'car rental.mdb;Persist Security Info=False';
conCarRental.LoginPrompt := false;
conCarRental.open;
ADOTblModels.Connection :=  conCarRental;
ADOTblModels.TableName := 'tblmodels';
ADOTblModels.Active := true;
DsrCarrental.DataSet := ADOTblModels;
Dbgcars.DataSource := DsrCarrental;
ADOTblModels.Active := true;
ADOTblRentals.TableName:= 'tblrentals';
ADOTblRentals.Active := true;
ADOTblGroups.TableName := 'tblgroups';
ADOTblGroups.Active := true;
end;


end.
