unit Unit1old;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, DB, ADODB, Grids, DBGrids, StdCtrls, ComCtrls,
  math, Mask, DBCtrls,  
  ExtCtrls;

type
  TForm1 = class(TForm)
    dsrCarRental: TDataSource;
    DbgCars: TDBGrid;
    ADOTblModels: TADOTable;
    conCarRental: TADOConnection;
    cmbTable: TComboBox;
    ADOTblRentals: TADOTable;
    ADOTblGroups: TADOTable;
    pgcCarRentals: TPageControl;
    tbsGrid: TTabSheet;
    tbsAdd: TTabSheet;
    tbsReport: TTabSheet;
    tbsMenu: TTabSheet;
    tbsNavigator: TTabSheet;
    btnGrid: TButton;
    btnAdd: TButton;
    btnReport: TButton;
    btnNavigator: TButton;
    ADOTblModelsModelID: TFloatField;
    ADOTblModelsModelName: TWideStringField;
    ADOTblModelsAC: TBooleanField;
    ADOTblModelsABS_brakes: TBooleanField;
    ADOTblModelsTank: TFloatField;
    ADOTblModelsSeats: TFloatField;
    ADOTblModelsRange: TFloatField;
    ADOTblRentalsID: TAutoIncField;
    ADOTblRentalsCarRegistration: TWideStringField;
    ADOTblRentalsDate_from: TDateTimeField;
    ADOTblRentalsDate_until: TDateTimeField;
    ADOTblRentalsModelID: TFloatField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    ADOTblGroupsGroupID: TWideStringField;
    ADOTblGroupsGroupdescription: TWideStringField;
    ADOTblGroupsRate_per_day: TBCDField;
    DbnCars: TDBNavigator;
    btnLocate: TButton;
    btnFirst: TButton;
    btnnext: TButton;
    btnprevious: TButton;
    btnRecNo: TButton;
    redReport: TRichEdit;
    ADOTblModelsGroupID: TWideStringField;
    DateTimePicker1: TDateTimePicker;
    ADOTblModelsAUTO: TBooleanField;
    ADOTblModelsPower_Steering: TBooleanField;
    ADOTblModelsCentral_locking: TBooleanField;
    ADOTblModelsAir_Bags: TBooleanField;
    ADOTblModelsDoors: TFloatField;
    MainMenu1: TMainMenu;
    Filters1: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    N81: TMenuItem;
    N91: TMenuItem;
    N101: TMenuItem;
    N111: TMenuItem;
    N121: TMenuItem;
    cmbGroups: TComboBox;
    ADOQry: TADOQuery;
    RadioGroup1: TRadioGroup;
    Activity771: TMenuItem;
    N23: TMenuItem;
    N33: TMenuItem;
    N43: TMenuItem;
    N53: TMenuItem;
    N63: TMenuItem;
    N72: TMenuItem;
    N82: TMenuItem;
    N92: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure cmbTableChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnGridClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnReportClick(Sender: TObject);
    procedure btnNavigatorClick(Sender: TObject);
    procedure btnLocateClick(Sender: TObject);
    procedure btnFirstClick(Sender: TObject);
    procedure ADOTblModelsAfterScroll(DataSet: TDataSet);
    procedure btnnextClick(Sender: TObject);
    procedure btnpreviousClick(Sender: TObject);
    procedure btnRecNoClick(Sender: TObject);



    procedure btnSortClick(Sender: TObject);
    procedure btnfilterClick(Sender: TObject);
    procedure btnfilterdatesClick(Sender: TObject);
    procedure btnfilternumbersClick(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure All1Click(Sender: TObject);
    procedure Some1Click(Sender: TObject);
    procedure Calculate1Click(Sender: TObject);
    procedure COunt1Click(Sender: TObject);
    procedure OtalandAvg1Click(Sender: TObject);
    procedure N22Click(Sender: TObject);
    procedure N32Click(Sender: TObject);
    procedure Allfields1Click(Sender: TObject);
    procedure Somerecords1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}



procedure TForm1.ADOTblModelsAfterScroll(DataSet: TDataSet);
begin
{try
showmessage(ADOTblModels['model name']+' with '+ inttostr(ADOTblModels['seats'])+ 'seats')
except
showmessage('cannot display');
end;                }
end;

procedure TForm1.All1Click(Sender: TObject);
begin
ADOtblModels.open;
ADOtblModels.first;

redReport.lines.add('ID'+#9+'Model');
while not ADOtblModels.Eof do
begin
redReport.lines.add(inttostr(ADOtblModels['ModelID'])+ #9 +ADOtblModels['Model name']);
ADOtblModels.next;
end;
ADOtblModels.close;
end;

procedure TForm1.Allfields1Click(Sender: TObject);
begin
ADOqry.close;
ADOqry.sql.text:='Select [Model Name], seats FROM tblModels';
ADOqry.open;

end;

procedure TForm1.btnAddClick(Sender: TObject);
begin
tbsAdd.show
end;

procedure TForm1.btnGridClick(Sender: TObject);
begin
tbsGrid.show
end;

procedure TForm1.btnLocateClick(Sender: TObject);
var s: string;
    sts : integer;
begin
s:=inputbox('Input','Model name:','');
sts:=strtoint(inputbox('Input','seats:',''));
If ADOTblModels.Locate('Model Name;Seats', VarArrayOf([s,sts]), [loPartialKey,loCaseInsensitive])
Then lbllocate.Caption := ADOTblModels['Model name']+ #9 + inttostr(ADOTblModels['ModelID'])
Else showmessage('Model name = '+ s +' not found');

end;

procedure TForm1.btnNavigatorClick(Sender: TObject);
begin
tbsNavigator.Show;
end;

procedure TForm1.btnnextClick(Sender: TObject);
begin
dsrCarRental.DataSet := ADOTblModels;
ADOTblModels.next;
showmessage(ADOTblModels['model name']+' with '+ inttostr(ADOTblModels['seats'])+ 'seats');

end;

procedure TForm1.btnpreviousClick(Sender: TObject);
begin
dsrCarRental.DataSet := ADOTblModels;
ADOTblModels.prior;
showmessage(ADOTblModels['model name']+' with '+ inttostr(ADOTblModels['seats'])+ 'seats');

end;

procedure TForm1.btnRecNoClick(Sender: TObject);
var sn: string;
    n : integer;
begin
dsrCarRental.DataSet := ADOTblModels;
repeat
 sn := inputbox('Input','Enter record number ','0');
until trystrtoint(sn,n) and (n >=0) and (n <= ADOTblModels.RecordCount);
ADOTblModels.recno := n;
showmessage(ADOTblModels['model name']+' with '+ inttostr(ADOTblModels['seats'])+ 'seats');

end;

procedure TForm1.btnReportClick(Sender: TObject);
begin
tbsReport.show
end;

procedure TForm1.btnSortClick(Sender: TObject);
begin
ADOTblModels.Sort := '[model name] DESC'
end;



procedure TForm1.Calculate1Click(Sender: TObject);

Var
       days : integer;
       cost : real;
begin
adotblgroups.open;
adotblgroups.First;
Days := strtoint(inputbox('Input','How many days',''));
while not adotblgroups.Eof do
	begin
	Cost := days* adotblgroups['Rate_per_day'];
	redreport.lines.add('Cost for '+inttostr(days)+
	' for a Group '+ adotblgroups['groupid'] +' car:'+ 	floattostrf(cost,ffcurrency,6,2));
	adotblgroups.Next;
	end

end;

procedure TForm1.btnfilterClick(Sender: TObject);
begin
ADOTblGroups.Filtered := false;

ADOTblgroups.Filter := 'Groupid = ''A''OR Groupid = ''B''';
ADOTblgroups.Filtered := true;
end;

procedure TForm1.btnfilterdatesClick(Sender: TObject);
var d : string;
begin

ADOTblRentals.Filtered := false;
//ADOTblRentals.Filter := 'date_from = #2013/10/07#';
//ADOTblRentals.Filter := 'date_from >=#2013/10/03# and date_from <=#2013/10/10#';
ADOTblRentals.Filter := 'carregistration like ''%KZN%''';
//D := datetostr(datetimepicker1.date);
//ADOTblRentals.Filter := 'date_from = #'+ d + '#';
//ADOTblRentals.Filter := 'date_from like #2013/10/%#'; xxx

//ADOTblRentals.Filter := 'month([date_from]) = 10'; xxx
ADOTblRentals.Filtered := true;
end;

procedure TForm1.btnfilternumbersClick(Sender: TObject);
var s: string;
begin

ADOTblModels.Filtered := false;
//ADOTblModels.Filter := 'Tank >40 AND seats = 4';
//ADOTblModels.Filter := '[model name] like ''T%'' or [model name] like ''V%'' ';
ADOTblModels.Filter := '[model name] like ''%x%''';
//ADOTblModels.Filter := '[model name] = ''Toyota Yaris T1''';
//ADOTblModels.Filter := '[model name] = '+quotedstr('Toyota Yaris T1');
//s:= inputbox('Input','Enter model name:','');
//ADOTblModels.Filter :=
	 //	 '[model name] like ' +quotedstr(s);
//s:= inputbox('Input','Enter number of seats:','');
//ADOTblModels.Filter :=
	//	 'Seats = ' +s;
//ADOTblModels.Filter := '[A/C] = true and auto = true';
//ADOTblModels.Filter := 'seats <> 4';

//ADOTblModels.Filter := 'range is null'; xxxx
//ADOTblModels.Filter := 'modelid between 10 and 13';xxx
ADOTblModels.Filtered := true;
end;

procedure TForm1.btnFirstClick(Sender: TObject);
begin
dsrCarRental.DataSet := ADOTblModels;
ADOTblModels.First;
showmessage(ADOTblModels['model name']+' with '+ inttostr(ADOTblModels['seats'])+ 'seats');

end;

procedure TForm1.cmbTableChange(Sender: TObject);
begin
case cmbTable.ItemIndex of
0:  dsrCarRental.DataSet := ADOTblModels;
1:  dsrCarRental.DataSet := ADOTblRentals;
2:  dsrCarRental.DataSet := ADOTblGroups;
end;
end;

procedure TForm1.COunt1Click(Sender: TObject);

Var
       counters : array['A'..'K'] of integer;
  c: Char;
begin
for c := 'A' to 'K' do
    counters[c] := 0;

adotblmodels.open;
adotblmodels.First;
while not adotblmodels.Eof do
	begin
  c:= adotblmodels.FieldByName('groupid').AsString[1];
	inc(counters[c]);
	adotblmodels.Next;
	end;
for c := 'A' to 'K' do
   if counters[c] <> 0 then redreport.Lines.Add('Group '+c+#9+ inttostr(counters[c]))
end;


procedure TForm1.FormActivate(Sender: TObject);
begin
pgcCarRentals.ActivePage := tbsGrid;
//populate combobox
cmbGroups.Text := 'Choose a group';
ADOTblGroups.First;
while not ADOTblGroups.Eof do
begin
cmbGroups.items.add(ADOTblGroups['Groupid']);
ADOTblGroups.Next;
end;
//populate listbox
cmbGroups.Text := 'Choose a group';
ADOTblGroups.First;
while not ADOTblGroups.Eof do
begin
lstGroups.items.add(ADOTblGroups['Groupid']);
ADOTblGroups.Next;
end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
conCarRental.Close;
conCarRental.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source='
+ExtractFilePath(Application.ExeName) +'car rental.mdb;Persist Security Info=False';
conCarRental.LoginPrompt := false;
conCarRental.open;
ADOTblModels.Connection :=  conCarRental;
ADOTblModels.TableName := 'tblmodels';
ADOTblModels.Active := true;
DsrCarrental.DataSet := ADOTblModels;
Dbgcars.DataSource := DsrCarrental;
ADOTblModels.Active := true;
ADOTblRentals.Active := true;
ADOTblGroups.Active := true;
end;

procedure TForm1.N12Click(Sender: TObject);
var i,c : integer;
begin
//1.	Display the ModelID and Model name of all cars in group A (groupid = ''A'') in two columns in the richedit on tbsReports, using a filter and looping through the filtered set.
ADOtblModels.filtered := false;
ADOtblModels.filter := 'Groupid = ''A'' ';
ADOtblModels.filtered := true;
ADOtblModels.findfirst;
for I := 1 to ADOtblModels.RecordCount-1 do
   begin
   redReport.lines.add(inttostr(ADOtblModels['ModelID'])+ #9 +ADOtblModels['Model name']);
   ADOtblModels.findnext;
   end;
redReport.lines.add(inttostr(ADOtblModels['ModelID'])+ #9 +ADOtblModels['Model name']);
ADOtblModels.close;
end;






procedure TForm1.N22Click(Sender: TObject);
begin
//2.	Count how many cars from Gauteng (GP) and Mpumalanga (MP) are in the fleet and display the results in the richedit on tbsReports
ADOtblRentals.filtered := false;
ADOtblRentals.filter := 'carregistration like ''%GP%'' ';
ADOtblRentals.filtered := true;
redReport.lines.add('Number of cars from Gauteng (GP)'+#9+inttostr(ADOtblRentals.RecordCount));
ADOtblRentals.filtered := false;
ADOtblRentals.filter := 'carregistration like ''%MP%'' ';
ADOtblRentals.filtered := true;
redReport.lines.add('Number of cars from Mpumalanga (MP)'+#9+inttostr(ADOtblRentals.RecordCount));

end;

procedure TForm1.N32Click(Sender: TObject);
var c : char;
begin
for c:= 'A' to 'K' do
begin
if c in ['A','B','D','F','G','H','J','K'] then
begin
ADOtblModels.filtered := false;
ADOtblModels.filter := 'Groupid ='+ quotedstr(c);
ADOtblModels.filtered := true;
redReport.lines.add('Number of cars in group '+c +#9+inttostr(ADOtblModels.RecordCount));
end;
end;
end;

procedure TForm1.OtalandAvg1Click(Sender: TObject);
Var
  total :real;
  counter : integer;
  c: Char;
begin
adotblgroups.open;
adotblgroups.First;
total:= 0;
counter := 0;
while not adotblgroups.Eof do
	begin
  total:=total+ adotblgroups['rate_per_day'];
  inc(counter);
	adotblgroups.Next;
	end;

redReport.Clear;
redreport.Lines.Add('Total '+#9+ floattostr(total));
redreport.Lines.Add('Average '+#9+ floattostr(total/counter));
end;

procedure TForm1.Some1Click(Sender: TObject);
begin
ADOtblModels.open;
ADOtblModels.first;

redReport.lines.add('ID'+#9+'Model');
while not ADOtblModels.Eof do
begin
if ADOTblModels['groupid'] = 'A' then
redReport.lines.add(inttostr(ADOtblModels['ModelID'])+ #9 +ADOtblModels['Model name']);
ADOtblModels.next;
end;
ADOtblModels.close;
end;

procedure TForm1.Somerecords1Click(Sender: TObject);
begin
dsrCarRental.DataSet := ADOqry;
ADOqry.close;
//ADOqry.sql.text:='Select carregistration  FROM tblRentals '
//+ 'WHERE carregistration  like  ''%KZN''  '
//+ 'or carregistration  like ''%GP''';
ADOqry.sql.text:='Select * FROM tblRentals where date_from =#2013/10/03#';
ADOqry.open;

end;

end.
